

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   mfcalc 2.0, Extended GNU Bison Example #3                     *
    *   Copyright  2005 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under GPL.                       *
    *   See GPL.txt for details.                         2005-02-23   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "functions.h"


/* --------------------------------------------------- */
double
OWN_above (double a, double b)
{
	return (a > b) ? 1.0 : 0.0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_avg (argrec * args)
{
	int i = 0;
	double sum = 0;

	while (args != 0)
	{
		i++;
		sum += args->val;
		args = args->next;
	}

	return sum / i;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_band (double a, double b)
{
	return ((a != 0.0) && (b != 0.0)) ? 1.0 : 0.0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_below (double a, double b)
{
	return (a < b) ? 1.0 : 0.0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_bnot (double x)
{
	return (x == 0.0) ? 1.0 : 0.0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_bor (double a, double b)
{
	return ((a != 0.0) || (b != 0.0)) ? 1.0 : 0.0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_cmp (double a, double b)
{
	if (a > b)
	{
		return 1.0;
	}
	if (a < b)
	{
		return -1.0;
	}
	return 0.0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_deg (double rad)
{
	return (rad * 180 / 3.141592653);
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_equal (double a, double b)
{
	return (a == b) ? 1.0 : 0.0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_if (double cond, double yes, double no)
{
	return (cond == 0) ? no : yes;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_intmod (double a, double b)
{
	return (double)((int)a % (int)b);
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_ld (double x)
{
	return 1.44269504088896 * log(x);
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_max (argrec * args)
{
	double max = 0;
	while (args != 0)
	{
		if (args->val > max)
		{
			max = args->val;
		}
		args = args->next;
	}

	return max;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_min (argrec * args)
{
	double min = args->val;
	while (args != 0)
	{
		if (args->val < min)
		{
			min = args->val;
		}
		args = args->next;
	}

	return min;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_rad (double deg)
{
	return (2 * 3.141592653 * deg / 360);
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_rnd ()
{
	return rand() / (double) RAND_MAX;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_sign (double x)
{
	if (x == 0)
	{
		return 0;
	}
	if (x > 0)
	{
		return 1.0;
	}
	return -1.0;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_sqr (double x)
{
	return x * x;
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_stdev (argrec * args)
{
	return sqrt(OWN_var(args));
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_time ()
{
	return (double)(unsigned)time(0);
}
/* --------------------------------------------------- */


/* --------------------------------------------------- */
double
OWN_var (argrec * args)
{
	double avg = OWN_avg(args);

	int i = 0;
	double sum = 0;

	while (args != 0)
	{
		i++;
		sum += OWN_sqr(args->val - avg);
		args = args->next;
	}

	return sum / i;
}
/* --------------------------------------------------- */
